<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { ref, computed, inject } from 'vue';
import { storeToRefs } from 'pinia';
import ChatBubble from '@/components/general/ChatBubble.vue';
import ImageMaskModal from '@/components/general/ImageMaskModal.vue';
import { useBaseStore } from '@/stores/base';
import Image from '@/components/general/Image.vue';
import { request } from '@/lib/request';
import { useI18n } from 'vue-i18n';
import { useChatStore } from '@/stores/chat';

const { t } = useI18n();
const $t = t;
const configuration = inject<any>('configuration');const baseStore = useBaseStore();
const { message: notificationMessage } = storeToRefs(baseStore);
const chatStore:any = useChatStore();
const { isShared } = storeToRefs(chatStore);

const props = defineProps<{
    user: string,
    avatar?: string,
    message: string,
    option?: string,
    isLast?: boolean
}>();

const emits = defineEmits<{
    (e: 'impainting', image: string, mask: string, prompt: string): void,
    (e: 'variation', image: string):void
}>();

const handleSave = async()=>{
    const image = await request('GET', getPath.value, undefined, undefined, true, false);
    const url = window.URL.createObjectURL(new Blob([image]));
    const link = document.createElement("a");
    link.href = url;
    link.setAttribute("download", "image.png");
    document.body.appendChild(link);
    link.click();
    link?.parentNode?.removeChild(link);

    notificationMessage.value = $t("ai.chat.notification.image.download.label");
};

const getPath = computed(()=>{
    return configuration.apiServer + props.message;
});

const showImageMaskModal = ref(false);
const handleShowImageMaskModal = ()=>{
    showImageMaskModal.value = true;
};

const handleSubmitImageMask = (mask: string, prompt: string)=>{
    handleCloseImageMaskModal();
    emits('impainting', props.message, mask, prompt);
};

const handleCloseImageMaskModal = ()=>{
    showImageMaskModal.value = false;
};

const handleImageVariation = ()=>{
    emits('variation', props.message);
};

const getAvatarPath = computed(()=>{
    return configuration.apiServer + props.avatar;
});
</script>
<template>
    <div class="flex gap-2 w-full" :class="user==='system'?'flex-row':'flex-row-reverse'">
        <div class="min-w-8 min-h-8 max-w-8 max-h-8">
            <div class="min-w-8 min-h-8 max-w-8 max-h-8 rounded-full text-center leading-8"
                :class="user==='system'?'bg-gray-300 text-gray-500':'bg-accent1-default text-accent1-text'" v-if="!avatar"><i
                    class="ri-user-line ri-lg"></i></div>
            <img class="min-w-8 min-h-8 max-w-8 max-h-8 rounded-full object-contain" :src="getAvatarPath" v-else>
        </div>
        <div class="w-fit max-w-[calc(100dvw-49%)]">
            <ChatBubble :position="user==='system'?'left':'right'" :color="user === 'system' ?'#e2e8f0':'#ffffff'">
                <div class="bg-gray-300 w-fit rounded-b-md px-2 -mt-4 select-none" v-if="option"><div>{{$t(`ai.chat.option.${option}.label`)}}</div></div>
                <div class="flex flex-col gap-2">
                    <Image :src="getPath" />
                    <div class="flex flex-row gap-2" :class="user==='system'?'ml-0':'ml-auto'">
                        <!--<div class="flex flex-row gap-2" v-show="user==='system' && isShared">
                            <Tooltip :tooltip="$t('ai.chat.option.variation.label')" v-if="isLast">
                                <button class="rounded-md hover:bg-gray-300 size-5" @click="handleImageVariation"><i class="ri-image-add-line"></i></button>
                            </Tooltip>
                            <Tooltip :tooltip="$t('ai.chat.option.image.edit.label')" v-if="isLast">
                                <button class="rounded-md hover:bg-gray-300 size-5" @click="handleShowImageMaskModal"><i class="ri-image-edit-line"></i></button>
                            </Tooltip>
                        </div>-->
                        <Tooltip :tooltip="$t('ai.chat.option.image.download.label')">
                            <button class="rounded-md hover:bg-gray-300 size-5" @click="handleSave"><i class="ri-save-line"></i></button>
                        </Tooltip>
                    </div>
                </div>
            </ChatBubble>
        </div>
    </div>
    <ImageMaskModal :image="getPath" v-if="showImageMaskModal" @submit="handleSubmitImageMask" @close="handleCloseImageMaskModal"/>
</template>